__  __    __   __  _____      _            _          _____ _          _ _ 
 |  \/  |   \ \ / / |  __ \    (_)          | |        / ____| |        | | |
 | \  / |_ __\ V /  | |__) | __ ___   ____ _| |_ ___  | (___ | |__   ___| | |
 | |\/| | '__|> <   |  ___/ '__| \ \ / / _` | __/ _ \  \___ \| '_ \ / _ \ | |
 | |  | | |_ / . \  | |   | |  | |\ V / (_| | ||  __/  ____) | | | |  __/ | |
 |_|  |_|_(_)_/ \_\ |_|   |_|  |_| \_/ \__,_|\__\___| |_____/|_| |_|\___V 2.1
 if you need WebShell for Seo everyday contact me on Telegram
 Telegram Address : @jackleet
        
        
For_More_Tools: Telegram: @jackleet | Bulk Smtp support mail sender | Business Mail Collector | Mail Bouncer All Mail | Bulk Office Mail Validator | Html Letter private



Upload:

Command:

[email protected]: ~ $
#!/bin/bash
# SPDX-License-Identifier: GPL-2.0

lib_dir=$(dirname $0)/../../../net/forwarding

ALL_TESTS="
	mac_profile_test
"
NUM_NETIFS=4
source $lib_dir/lib.sh
source $lib_dir/tc_common.sh
source $lib_dir/devlink_lib.sh

h1_create()
{
	simple_if_init $h1 192.0.2.1/24
	ip route add 198.51.100.0/24 vrf v$h1 nexthop via 192.0.2.2

	tc qdisc add dev $h1 ingress
}

h1_destroy()
{
	tc qdisc del dev $h1 ingress

	ip route del 198.51.100.0/24 vrf v$h1
	simple_if_fini $h1 192.0.2.1/24
}

h2_create()
{
	simple_if_init $h2 198.51.100.1/24
	ip route add 192.0.2.0/24 vrf v$h2 nexthop via 198.51.100.2

	tc qdisc add dev $h2 ingress
}

h2_destroy()
{
	tc qdisc del dev $h2 ingress

	ip route del 192.0.2.0/24 vrf v$h2
	simple_if_fini $h2 198.51.100.1/24
}

router_create()
{
	ip link set dev $rp1 up
	ip link set dev $rp2 up

	tc qdisc add dev $rp1 clsact
	tc qdisc add dev $rp2 clsact
	ip address add 192.0.2.2/24 dev $rp1
	ip address add 198.51.100.2/24 dev $rp2
}

router_destroy()
{
	ip address del 198.51.100.2/24 dev $rp2
	ip address del 192.0.2.2/24 dev $rp1
	tc qdisc del dev $rp2 clsact
	tc qdisc del dev $rp1 clsact

	ip link set dev $rp2 down
	ip link set dev $rp1 down
}

setup_prepare()
{
	h1=${NETIFS[p1]}
	rp1=${NETIFS[p2]}

	rp2=${NETIFS[p3]}
	h2=${NETIFS[p4]}

	vrf_prepare

	h1_create
	h2_create

	router_create

	forwarding_enable
}

cleanup()
{
	pre_cleanup

	forwarding_restore

	router_destroy

	h2_destroy
	h1_destroy

	vrf_cleanup
}

h1_to_h2()
{
	local test_name=$@; shift
	local smac=$(mac_get $rp2)

	RET=0

	# Replace neighbour to avoid first packet being forwarded in software
	ip neigh replace dev $rp2 198.51.100.1 lladdr $(mac_get $h2)

	# Add a filter to ensure that packets are forwarded in hardware. Cannot
	# match on source MAC because it is not set in eACL after routing
	tc filter add dev $rp2 egress proto ip pref 1 handle 101 \
		flower skip_sw ip_proto udp src_port 12345 dst_port 54321 \
		action pass

	# Add a filter to ensure that packets are received with the correct
	# source MAC
	tc filter add dev $h2 ingress proto ip pref 1 handle 101 \
		flower skip_sw src_mac $smac ip_proto udp src_port 12345 \
		dst_port 54321 action pass

	$MZ $h1 -a own -b $(mac_get $rp1) -t udp "sp=12345,dp=54321" \
		-A 192.0.2.1 -B 198.51.100.1 -c 10 -p 100 -d 1msec -q

	tc_check_packets "dev $rp2 egress" 101 10
	check_err $? "packets not forwarded in hardware"

	tc_check_packets "dev $h2 ingress" 101 10
	check_err $? "packets not forwarded with correct source mac"

	log_test "h1->h2: $test_name"

	tc filter del dev $h2 ingress protocol ip pref 1 handle 101 flower
	tc filter del dev $rp2 egress protocol ip pref 1 handle 101 flower
	ip neigh del dev $rp2 198.51.100.1 lladdr $(mac_get $h2)
}

h2_to_h1()
{
	local test_name=$@; shift
	local rp1_mac=$(mac_get $rp1)

	RET=0

	ip neigh replace dev $rp1 192.0.2.1 lladdr $(mac_get $h1)

	tc filter add dev $rp1 egress proto ip pref 1 handle 101 \
		flower skip_sw ip_proto udp src_port 54321 dst_port 12345 \
		action pass

	tc filter add dev $h1 ingress proto ip pref 1 handle 101 \
		flower skip_sw src_mac $rp1_mac ip_proto udp src_port 54321 \
		dst_port 12345 action pass

	$MZ $h2 -a own -b $(mac_get $rp2) -t udp "sp=54321,dp=12345" \
		-A 198.51.100.1 -B 192.0.2.1 -c 10 -p 100 -d 1msec -q

	tc_check_packets "dev $rp1 egress" 101 10
	check_err $? "packets not forwarded in hardware"

	tc_check_packets "dev $h1 ingress" 101 10
	check_err $? "packets not forwarded with correct source mac"

	log_test "h2->h1: $test_name"

	tc filter del dev $h1 ingress protocol ip pref 1 handle 101 flower
	tc filter del dev $rp1 egress protocol ip pref 1 handle 101 flower
	ip neigh del dev $rp1 192.0.2.1 lladdr $(mac_get $h1)
}

smac_test()
{
	local test_name=$@; shift

	# Test that packets forwarded to $h2 via $rp2 are forwarded with the
	# current source MAC of $rp2
	h1_to_h2 $test_name

	# Test that packets forwarded to $h1 via $rp1 are forwarded with the
	# current source MAC of $rp1. This MAC is never changed during the test,
	# but given the shared nature of MAC profile, the point is to see that
	# changes to the MAC of $rp2 do not affect that of $rp1
	h2_to_h1 $test_name
}

mac_profile_test()
{
	local rp2_mac=$(mac_get $rp2)

	# Test behavior when the RIF backing $rp2 is transitioned to use
	# a new MAC profile
	ip link set dev $rp2 addr 00:11:22:33:44:55
	smac_test "new mac profile"

	# Test behavior when the MAC profile used by the RIF is edited
	ip link set dev $rp2 address 00:22:22:22:22:22
	smac_test "edit mac profile"

	# Restore original MAC
	ip link set dev $rp2 addr $rp2_mac
}

trap cleanup EXIT

setup_prepare
setup_wait

mac_profiles=$(devlink_resource_size_get rif_mac_profiles)
if [[ $mac_profiles -ne 1 ]]; then
	tests_run
fi

exit $EXIT_STATUS

Filemanager

Name Type Size Permission Actions
spectrum Folder 0755
spectrum-2 Folder 0755
blackhole_routes.sh File 4.96 KB 0755
devlink_linecard.sh File 7.5 KB 0755
devlink_trap.sh File 1.86 KB 0755
devlink_trap_acl_drops.sh File 2.4 KB 0755
devlink_trap_control.sh File 18.22 KB 0755
devlink_trap_l2_drops.sh File 12.87 KB 0755
devlink_trap_l3_drops.sh File 16.38 KB 0755
devlink_trap_l3_exceptions.sh File 13.64 KB 0755
devlink_trap_policer.sh File 9.75 KB 0755
devlink_trap_tunnel_ipip.sh File 5.24 KB 0755
devlink_trap_tunnel_ipip6.sh File 5.31 KB 0755
devlink_trap_tunnel_vxlan.sh File 8.84 KB 0755
devlink_trap_tunnel_vxlan_ipv6.sh File 9.32 KB 0755
egress_vid_classification.sh File 6.55 KB 0755
ethtool_lanes.sh File 4.02 KB 0755
extack.sh File 3.74 KB 0755
fib.sh File 5.43 KB 0755
fib_offload.sh File 9.93 KB 0755
hw_stats_l3.sh File 410 B 0755
ingress_rif_conf_1d.sh File 6.15 KB 0755
ingress_rif_conf_1q.sh File 6.23 KB 0755
ingress_rif_conf_vxlan.sh File 8.44 KB 0755
mirror_gre.sh File 3.78 KB 0755
mirror_gre_scale.sh File 5.43 KB 0644
mlxsw_lib.sh File 1.43 KB 0644
one_armed_router.sh File 6.82 KB 0755
pci_reset.sh File 1.27 KB 0755
port_range_occ.sh File 2.33 KB 0755
port_range_scale.sh File 1.51 KB 0644
port_scale.sh File 1.36 KB 0644
q_in_q_veto.sh File 8.06 KB 0755
qos_defprio.sh File 2.33 KB 0755
qos_dscp_bridge.sh File 4.14 KB 0755
qos_dscp_router.sh File 6.43 KB 0755
qos_ets_strict.sh File 9.09 KB 0755
qos_headroom.sh File 8.19 KB 0755
qos_lib.sh File 1.27 KB 0644
qos_max_descriptors.sh File 6.14 KB 0755
qos_mc_aware.sh File 9.54 KB 0755
qos_pfc.sh File 11.36 KB 0755
rif_bridge.sh File 4.12 KB 0755
rif_counter_scale.sh File 1.71 KB 0644
rif_lag.sh File 2.98 KB 0755
rif_lag_vlan.sh File 3.24 KB 0755
rif_mac_profile_scale.sh File 1.64 KB 0644
rif_mac_profiles.sh File 4.65 KB 0755
rif_mac_profiles_occ.sh File 2.87 KB 0755
router_bridge_lag.sh File 786 B 0755
router_scale.sh File 2.09 KB 0644
rtnetlink.sh File 26.93 KB 0755
sch_ets.sh File 2.3 KB 0755
sch_offload.sh File 5.25 KB 0755
sch_red_core.sh File 20.75 KB 0644
sch_red_ets.sh File 3.12 KB 0755
sch_red_prio.sh File 81 B 0755
sch_red_root.sh File 1.25 KB 0755
sch_tbf_ets.sh File 216 B 0755
sch_tbf_prio.sh File 217 B 0755
sch_tbf_root.sh File 217 B 0755
sharedbuffer.sh File 5.24 KB 0755
tc_action_hw_stats.sh File 2.24 KB 0755
tc_flower_scale.sh File 2.81 KB 0644
tc_police_occ.sh File 2.07 KB 0755
tc_police_scale.sh File 1.62 KB 0644
tc_restrictions.sh File 11.58 KB 0755
tc_sample.sh File 17.38 KB 0755
vxlan.sh File 30.19 KB 0755
vxlan_fdb_veto.sh File 3.11 KB 0755
vxlan_fdb_veto_ipv6.sh File 250 B 0755
vxlan_flooding.sh File 8.64 KB 0755
vxlan_ipv6.sh File 1.39 KB 0755
Filemanager